<template>
	<div class="create-sampling-collection-button">
		<v-btn color="primary" rounded :disabled="disabled" @click="handleClick(false)">Collect</v-btn>
		<div v-if="disabled" class="create-sampling-collection-button--disabled-text caption grey--text mt-1 ml-1">
			Collection cannot be started until the field is stratified.
		</div>
		<v-dialog
			v-model="showChooseSamplingCollectionDialog"
			@click:outside="showChooseSamplingCollectionDialog = false"
			max-width="50em"
		>
			<v-card>
				<v-toolbar color="grey lighten-2" flat>
					<v-toolbar-title>Begin Sampling Collection</v-toolbar-title>
				</v-toolbar>
				<v-divider />
				<v-card-text class="py-4">
					<div class="d-flex justify-center align-center mt-4 mx-2">
						<v-icon color="warning">mdi-exclamation-thick</v-icon>
						<v-divider vertical class="mx-2"></v-divider>
						<p class="mt-0 mb-0">
							You already have an in-progress sampling collection for this field. Choose a sampling collection to resume
							or start a new sampling collection.
						</p>
					</div>
					<v-list dense>
						<v-list-item dense v-for="samplingCollection in draftSamplingCollections" :key="samplingCollection.id">
							<router-link :to="`/sampling-collection/${samplingCollection.id}/edit`">
								{{ new Date(samplingCollection.dateCreated).toLocaleString() }}
							</router-link>
						</v-list-item>
					</v-list>
				</v-card-text>
				<v-divider />
				<v-card-actions class="d-flex flex-wrap justify-end">
					<v-btn class="mr-2" text rounded @click="showChooseSamplingCollectionDialog = false">Cancel</v-btn>
					<v-btn color="green" text rounded @click="handleClick(true)">New Collection</v-btn>
				</v-card-actions>
			</v-card>
		</v-dialog>
	</div>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api';
import { SamplingCollection } from '@/store/types';

export default defineComponent({
	name: 'CreateSamplingCollectionButton',
	props: {
		fieldId: {
			type: String,
			required: true,
		},
		locationCollectionId: {
			type: String,
		},
		draftSamplingCollections: {
			type: Array as () => SamplingCollection[],
		},
	},
	setup({ fieldId, locationCollectionId, draftSamplingCollections }, { root }) {
		const showChooseSamplingCollectionDialog = ref(false);
		return {
			handleClick(forceCreate: boolean) {
				if (forceCreate || !draftSamplingCollections || draftSamplingCollections.length === 0) {
					root.$router.push({
						path: '/create-sampling-collection',
						query: {
							field: fieldId,
							object: locationCollectionId,
						},
					});
				} else {
					showChooseSamplingCollectionDialog.value = true;
				}
			},
			disabled: !locationCollectionId,
			showChooseSamplingCollectionDialog,
		};
	},
});
</script>

<style>
.create-sampling-collection-button--disabled-text {
	max-width: 180px;
}
</style>
